/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited 
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

#ifndef __EPP_GENERICCHECKRSP_H
#define __EPP_GENERICCHECKRSP_H

/** @file epp_GenericCheckRsp.h
 *  @brief Definition of epp_GenericCheckRsp and epp_GenericCheckRsp_ref
 *  @author Asbjorn Steira Mikkelsen
 */

#include "epp_GenericRsp.h"
#include "epp_CheckResult.h"

namespace eppobject { namespace epp {
   
   /// Class containing the generic/common elements of the server response to a <check> command
   /// @see epp_GenericRsp for additional information
   class epp_GenericCheckRsp : public epp_GenericRsp {
      
    public:
      epp_check_result_seq_ref m_results; /**< Generic <check> response sequence */
      
      /// Null constructor
      epp_GenericCheckRsp() {};

      /// Destructor
      virtual ~epp_GenericCheckRsp() {}
      
      /// Constructor
      epp_GenericCheckRsp(const epp_Response_ref & _m_rsp,
			  const epp_check_result_seq_ref & _m_results)
	: epp_GenericRsp(_m_rsp)
	{
	   m_results = _m_results;
	};
   };

   /// Typedef for the ref to the epp_GenericCheckRsp class
   typedef refcnt_ptr<epp_GenericCheckRsp> epp_GenericCheckRsp_ref;
   
}}

#endif
