/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited 
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

#ifndef __EPP_GENERICREQ_H
#define __EPP_GENERICREQ_H

/** @file epp_GenericReq.h
 *  @brief Definition of epp_GenericReq and epp_GenericReq_ref
 *  @author Asbjorn Steira Mikkelsen
 */

#include "epp_Command.h"

namespace eppobject { namespace epp {
   
   /// Class containing the generic and common elements of a client request
   class epp_GenericReq {
      
    public:
      epp_Command_ref m_cmd; /**< Generic request element */
      
      /// Null constructor
      epp_GenericReq() {};
      
      /// Destructor
      virtual ~epp_GenericReq() {};
      
      /// Constructor
      epp_GenericReq(const epp_Command_ref & _m_cmd)
	{
	   m_cmd = _m_cmd;
	};

   };

   /// Typedef for the ref to the epp_GenericReq class
   typedef refcnt_ptr<epp_GenericReq> epp_GenericReq_ref;
   
}}

#endif
