/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited 
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

#ifndef __EPP_HOSTDELETERSP_H
#define __EPP_HOSTDELETERSP_H

/** @file epp_HostDeleteRsp.h
 *  @brief Definition of epp_HostDeleteRsp and epp_HostDeleteRsp_ref
 *  @author Asbjorn Steira Mikkelsen
 */

#include "epp_GenericRsp.h"

namespace eppobject { namespace host {
   
   /// Class containing elements used in host delete responses
   /// @see epp_GenericRsp for additional information
   class epp_HostDeleteRsp : public epp::epp_GenericRsp {
      
    public:
      
      /// Null constructor
      epp_HostDeleteRsp() {};
      
      /// Destructor
      virtual ~epp_HostDeleteRsp() {}
      
      /// Constructor
      epp_HostDeleteRsp(const eppobject::epp::epp_Response_ref & _m_rsp)
	: epp::epp_GenericRsp(_m_rsp) {};
      
   };

   /// Typedef for the ref to the epp_HostDeleteRsp class
   typedef refcnt_ptr<epp_HostDeleteRsp> epp_HostDeleteRsp_ref;
   
}}

#endif
