/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited 
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

#ifndef __EPP_HOSTUPDATEADDREMOVE_H
#define __EPP_HOSTUPDATEADDREMOVE_H

/** @file epp_HostUpdateAddRemove.h
 *  @brief Definition of epp_HostUpdateAddRemove and epp_HostUpdateAddRemove_ref
 *  @author Asbjorn Steira Mikkelsen
 */
#include "epp_hostdata.h"
#include "epp_HostAddress.h"
#include "epp_HostStatus.h"

namespace eppobject { namespace host {
   
   /// Class containing elements used in add/remove part of host update requests
   class epp_HostUpdateAddRemove {
      
    public:
      epp_host_address_seq_ref m_addresses; /**< IP addresses (to be) associated with the host */
      epp_host_status_seq_ref m_status; /**< Status of the host object */

      /// Null constructor
      epp_HostUpdateAddRemove() {};
      
      /// Destructor
      virtual ~epp_HostUpdateAddRemove() {};

      /// Constructor, using only references
      epp_HostUpdateAddRemove(const epp_host_address_seq_ref & _m_addresses,
			      const epp_host_status_seq_ref & _m_status)
	{
	   m_addresses = _m_addresses;
	   m_status = _m_status;
	};
   };
   
   /// Typedef for the ref to the epp_HostUpdateAddRemove class
   typedef refcnt_ptr<epp_HostUpdateAddRemove> epp_HostUpdateAddRemove_ref;
   
}}

#endif
