/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited 
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

#ifndef __EPP_POLLDOMAINTRANSFER_H
#define __EPP_POLLDOMAINTRANSFER_H

/** @file epp_PollDomainTransfer.h
 *  @brief Deprecated! Definition of epp_PollDomainTransfer and epp_PollDomainTransfer_ref
 *  @author Asbjorn Steira Mikkelsen
 *  @deprecated Replaced by epp_DomainTrnData.h from EPP 04/02, IDL 05/03
 */

#include "epp_eppdata.h"
#include "epp_AuthInfo.h"

namespace eppobject { namespace epp {

   /// Class containing elements used in poll responses to describe a domain transfer
   /// @deprecated Replaced by eppobject::domain::epp_DomainTrnData from EPP 04/02, IDL 05/03
   class epp_PollDomainTransfer {
      
    public:
      epp_string_ref m_domain_name; /**< Fully qualified name of the domain object requested for transfer */
      epp_AuthInfo_ref m_auth_info; /**< Authorization information associated with domain */
      
      /// Null constructor
      epp_PollDomainTransfer() {};
      
      /// Destructor
      virtual ~epp_PollDomainTransfer() {};
      
      /// Constructor, using simple types when it can
      /// @note Cannot set simple types to NULL
      epp_PollDomainTransfer(const epp_string & _m_domain_name,
			     const epp_AuthInfo_ref & _m_auth_info)
	{
	   m_domain_name.ref(new epp_string(_m_domain_name));
	   m_auth_info = _m_auth_info;
	};
      
      /// Constructor, using only references
      epp_PollDomainTransfer(const epp_string_ref & _m_domain_name,
			     const epp_AuthInfo_ref & _m_auth_info)
	{
	   m_domain_name = _m_domain_name;
	   m_auth_info = _m_auth_info;
	};
   };
   
   /// Typedef for the ref to the epp_PollContactTransfer class
   typedef refcnt_ptr<epp_PollDomainTransfer> epp_PollDomainTransfer_ref;
   
}}

#endif
