/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited 
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

#ifndef __EPP_POLLRESDATA_H
#define __EPP_POLLRESDATA_H

/** @file epp_PollResData.h
 *  @brief Definition of epp_PollResData and epp_PollResData_ref
 *  @author Asbjorn Steira Mikkelsen
 */

#include "epp_eppdata.h"
#include <domtools/dom_wrapper.h>

namespace eppobject { namespace epp {
   
   class epp_PollResData; // Forward declaration...
   /// Typedef for the ref to the epp_PollResData class
   typedef refcnt_ptr<epp_PollResData> epp_PollResData_ref;
   
   /// Abstract class containing elements used in resData-part of poll responses
   class epp_PollResData {
      
    protected:
      epp_string m_type; /**< The type of poll resData object */
      
    public:
      
      /// Null constructor
      epp_PollResData() {};
      
      /// Destructor
      virtual ~epp_PollResData() {};
      
      /// Returns the type of resData object
      virtual epp_string getType() = 0;
      
      /// Parses a trnData dom_ptr, fills in the public attributes of the class,
      /// and returns a ref to an epp_PollResData object
      virtual epp_PollResData_ref createPollResData(const domtools::dom_ptr & trnNode) = 0;

   };
   
   
}}

#endif
