/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited 
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

#include "epp_Session.h"
#include "epp_Hello.h"

using namespace std;
using namespace eppobject::epp;


epp_Action_ref epp_Session::processAction(epp_Action_ref request)
{
   string request_xml = request->toXML();
   
   string response_xml = processXML(request_xml);
   
   request->fromXML(response_xml);
   
   return request;
};


epp_string epp_Session::processXML(const epp_string & request_xml)
{
   m_transport->writeToServer(request_xml);
   
   epp_string xml = m_transport->readFromServer();
   
   // Deleting leading whitespace from response:
   string::size_type firstNotWhite = xml.find_first_not_of(" \t\r\n");
   if(firstNotWhite != string::npos && firstNotWhite != 0) {
      xml.erase(0, firstNotWhite);
   }
   
   return xml;
};


epp_Greeting_ref epp_Session::connectAndGetGreeting()
{
   epp_Greeting_ref gr;
   
   m_transport->connect();   
   epp_string grStr = m_transport->readFromServer();
   
   epp_Hello hello;
   hello.fromXML(grStr);
   gr = hello.getResponseData();
   
   return gr;
}
