/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

#ifndef __EPP_UNSPEC_H
#define __EPP_UNSPEC_H

/** @file epp_Unspec.h
 *  @brief Deprecated! Definition of epp_Unspec and epp_Unspec_ref
 *  @author Asbjorn Steira Mikkelsen
 *  @deprecated Replaced by epp_Extension.h from IDL 05/03
 */

#include "data/epp_eppdata.h"

namespace eppobject { namespace epp {
   
   /// Unspecified element used for server-defined command extensions.
   /// @deprecated Replaced by epp_Extension from IDL 05/03
   class epp_Unspec {

    public:
      
      /// Constructor
      epp_Unspec() {};

      /// Deconstructor
      virtual ~epp_Unspec() {};
      
      /** Abstract function used to parse an epp object, and then return the
       *  corresponding correctly formatted EPP xml as an #epp_string
       *  To be overloaded by sub-classes.
       * @return An empty #epp_string
       */
      virtual eppobject::epp::epp_string toXML() { return eppobject::epp::epp_string(); };
      
      /** Abstract function used to parse an #epp_string, and put the elements into an
       *  epp object. To be overloaded by sub-classes
       * @param xml An XML #epp_string
       */
      virtual void fromXML(const eppobject::epp::epp_string &) {};
   };
   
   /// Typedef for the ref to the epp_Unspec class
   typedef refcnt_ptr<epp_Unspec> epp_Unspec_ref;
   
}}

#endif
