/************************************************************************
 * EPP RTK C++
 * Copyright (C) 2001, 2002 The Global Name Registry, Limited 
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact information:  epprtk@gnr.com
 *
 *                       EPP RTK
 *                       The Global Name Registry, Limited
 *                       125 High Holborn
 *                       London WC1V 6QA
 *                       United Kingdom
 ************************************************************************/

/** @file epp_TransportIOStream.cc
 *  @brief Definition of epp_TransportIOStream functions
 *  @author Asbjorn Steira Mikkelsen
 *  @see epp_TransportIOStream.h
 */

#include "epp_TransportIOStream.h"


using namespace std;
using namespace epptransport;


void epp_TransportIOStream::writeToServer(const string & xml_string)
{
   cout << "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n";
   cout << xml_string;
   cout << endl;

#ifdef TEST_IO_REQUEST2CERR
   cerr << "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n";
   cerr << xml_string << endl;
#endif
}


string epp_TransportIOStream::readFromServer()
{
   string s;
   char c;

   //lint -e534
   // We are not interested in the return values of cin.get() here
   while(cin) {
      cin.get(c);
      s += c;
      if(c == '<') { // if "<"
	 cin.get(c);
	 s += c;
	 if(c == '/') { // if "</"
	    cin.get(c);
	    s += c;
	    if(c == 'e') { // if "</e"
	       cin.get(c);
	       s += c;
	       if(c == 'p') { // if "</ep"
		  cin.get(c);
		  s += c;
		  if(c == 'p') { // if "</epp"
		     cin.get(c);
		     s += c;
		     if(c == '>') { // if "</epp>"
			break;
		     } // if "</epp>"
		  } // if "</epp"
	       } // if "</ep"
	    } // if "</e"
	 } // if "</"
      } // if "<"
      
   } // while
   //lint +e534
   
   return s;
}
