/************************************************************************
* EPP RTK C++
* Copyright (C) 2001, 2002 The Global Name Registry, Limited 
* 
* This library is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as published
* by the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
*
* This library is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* Contact information:  epprtk@gnr.com
*
*                       EPP RTK
*                       The Global Name Registry, Limited
*                       125 High Holborn
*                       London WC1V 6QA
*                       United Kingdom
************************************************************************/

#ifndef __EPP_WEATHER_H
#define __EPP_WEATHER_H

/** @file epp_Weather.h
 *  @brief Definition of epp_Weather and epp_Weather_ref
 *  @author Asbjorn Steira Mikkelsen
 */

#include "../data/epp_eppdata.h"

namespace eppobject { namespace epp {

   /// Class containing elements used to hold information about weather
   class epp_Weather {
      
    public:
      epp_string_ref m_today; /**< Today's weather */
      epp_string_ref m_tomorrow; /**< Tomorrow's weather */
     
      /// Null constructor
      epp_Weather() {};
      
      /// Destructor
      virtual ~epp_Weather() {};
      
      /// Constructor, using simple types when it can
      /// @note Cannot set simple types to NULL
      epp_Weather(epp_string _m_today,
		  epp_string _m_tomorrow)
	{
	   m_today.ref(new epp_string(_m_today));
	   m_tomorrow.ref(new epp_string(_m_tomorrow));
	};
      
      /// Constructor, using only references
      epp_Weather(epp_string_ref _m_today,
		  epp_string_ref _m_tomorrow)
	{
	   m_today = _m_today;
	   m_tomorrow = _m_tomorrow;
	};
   };

   /// Typedef for the ref to the epp_Weather class
   typedef refcnt_ptr<epp_Weather> epp_Weather_ref;
   
}};

#endif
