#!/usr/bin/perl

# This script takes the classes created by the idlj program and adds gets and sets
# for the data members.  Yes, the members are public already, but this makes the 
# epp_* classes useful as beans with properties that can be set and gotten.

foreach ( @ARGV )
{

    $filename = $_;
    print "Processing $filename...";
    
    if ( not open INFILE, $filename )
    {
        print "skipping\n";
        next;
    }
    
    open OUTFILE, ">$filename.tmp";

    my $sets_and_gets = "";
    my $to_string = '  public String toString() { return this.getClass().getName() + ": {';

    while (<INFILE>)
    {
        my $inputline = $_;

        if ( $inputline =~ /public\s+(\S*)\s(\S*)\[\] = / )
        {
            # Array types
            my $type = $1;
            my $variable = $2;
            my $upper_variable = $2;
            $upper_variable =~ s/^m_//;
            $upper_variable =~ s/_([a-z])/\u$1/g;
            $upper_variable =~ s/^([a-z])/\u$1/;

            $sets_and_gets .= "  public void set$upper_variable($type\[\] value) { $variable = value; }\n";
            $sets_and_gets .= "  public $type\[\] get$upper_variable() { return $variable; }\n\n";
            $to_string .= " $variable [\"+($variable != null ? java.util.Arrays.asList($variable) : null)+\"]";

            print OUTFILE $inputline;
        }
        elsif ( $inputline =~ /public\s+(\S*)\s(\S*) = / )
        {
            # singular types
            my $type = $1;
            my $variable = $2;
            my $upper_variable = $2;
            $upper_variable =~ s/^m_//;
            $upper_variable =~ s/_([a-z])/\u$1/g;
            $upper_variable =~ s/^([a-z])/\u$1/;

            $sets_and_gets .= "  public void set$upper_variable($type value) { $variable = value; }\n";
            $sets_and_gets .= "  public $type get$upper_variable() { return $variable; }\n\n";
            $to_string .= " $variable [\"+$variable+\"]";

            print OUTFILE $inputline;
        }
        elsif ( $inputline =~ /^}/ )
        {
            if ( $sets_and_gets !~ /^$/ )
            {
                print OUTFILE $sets_and_gets;
                $to_string .= ' }"; }'."\n\n";
                print OUTFILE $to_string;
            }
            print OUTFILE $inputline;
        }
        elsif ( $inputline =~ /public final class/ )
        {
            $inputline =~ s/ final / /;
            print OUTFILE $inputline;
        }
        else
        {
            print OUTFILE $inputline;
        }
    }

    close OUTFILE;
    close INFILE;

    open INFILE, "$filename.tmp";
    open OUTFILE, ">$filename";
    while (<INFILE>)
    {
        print OUTFILE $_;
    }
    close OUTFILE;
    close INFILE;
    unlink "$filename.tmp";
    
    print "done\n";

}
